<script setup>
// Import Vue composition API
import { ref, onMounted } from "vue";

// Import API instance
import api from "../../api";

// Define state for search query and books
const searchQuery = ref("");

// Define state for books
const bukus = ref([]);

// Function to fetch book data
const fetchDataBukus = async () => {
  try {
    const response = await api.get("/buku");
    // Set response data to state "bukus"
    bukus.value = response.data;
    console.log(bukus.value);
  } catch (error) {
    console.error("Error fetching data:", error);
  }
};

// Function to search books
const searchBooks = async () => {
  try {
    const response = await api.get("/buku", {
      params: {
        search: searchQuery.value,
      },
    });
    // Set response data to state "bukus"
    bukus.value = response.data;
  } catch (error) {
    console.error("Error searching books:", error);
  }
};

// Run fetch data function when component is mounted
onMounted(() => {
  fetchDataBukus();
});

// Function to format price
const formatPrice = (price) => {
  return price
    .toFixed(2)
    .replace(/\d(?=(\d{3})+\.)/g, "$&.")
    .replace(".", ",");
};
</script>

<template>
  <section class="bg-primary pt-5">
    <div class="container">
      <div class="row pt-5">
        <h2 class="text-center text-white">
          Explore the fascinating world of <br />
          Fiction Books
        </h2>
      </div>
      <form @submit.prevent="searchBooks" class="form-inline">
        <div class="input-group pt-3 pb-5 center">
          <input v-model="searchQuery" type="text" class="form-control" placeholder="Cari buku disini..." />
          <div class="input-group-append">
            <button class="btn btn-secondary" type="submit">
              <i class="fa fa-search"></i>
            </button>
          </div>
        </div>
      </form>
    </div>
  </section>
  <section>
    <div class="container py-4 vh-100">
      <div class="row">
        <h3>Daftar Buku Kami!</h3>
        <div class="row">
          <div v-if="bukus.length == 0">
            <div class="alert alert-danger mb-0">Data Belum Tersedia!</div>
          </div>
        </div>
        <div class="row">
          <div class="col" v-for="Buku in bukus" :key="Buku.buku_id" style="margin-bottom: 20px">
            <div class="card" style="width: 15rem; height: auto; margin: 0 auto">
              <div class="card-body" style="
                  display: flex;
                  flex-direction: column;
                  justify-content: space-between;
                ">
                <div class="frame" style="width: 207px; height: 311px">
                  <img :src="Buku.cover" class="card-img-top pb-3" style="
                      max-width: 100%;
                      max-height: 100%;
                      object-fit: cover;
                      object-position: center;
                    " alt="" />
                </div>
                <h5 class="card-title text-truncate">{{ Buku.title }}</h5>
                <p class="card-text m-0" style="max-width: 100%; color: rgb(88, 83, 83)">
                  {{ Buku.author }}
                </p>
                <p class="card-text" style="max-width: 100%; color: darkcyan">
                  Rp{{ formatPrice(Buku.price) }}
                </p>
                <router-link :to="{
                  path: `/buku/${Buku.buku_id}`,
                }" class="btn btn-primary" style="margin-top: auto">
                  Lihat
                </router-link>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>
